<?php

define('PHPWG_ROOT_PATH','../../../');
define('IN_ADMIN', true);
include_once(PHPWG_ROOT_PATH.'include/common.inc.php' );
include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
include_once(PHPWG_ROOT_PATH.'admin/include/functions_plugins.inc.php');

if (!defined('AUTOUPDATE_PATH'))
  define('AUTOUPDATE_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(dirname(__FILE__))) . '/');

check_status(ACCESS_ADMINISTRATOR);

if (!is_webmaster())
{
  echo json_encode(array(
    'result' => false,
    'msg' => l10n('Webmaster status is required.'),
    )
  );
  exit;
}

include_once(PHPWG_ROOT_PATH.'admin/include/plugins.class.php');
$plugins = new plugins();

if (isset($_GET['upgradestatus']) and isset($_GET['id']))
{
  switch ($_GET['upgradestatus'])
  {
    case 'ok':
      $result = array(
        'result' => true,
        'msg' => sprintf(l10n('%s has been successfully upgraded.'), $plugins->fs_plugins[$_GET['id']]['name'])
      );
      break;

    case 'temp_path_error':
      $result = array(
        'result' => false,
        'msg' => l10n('Can\'t create temporary file.')
      );
      break;

    case 'dl_archive_error':
      $result = array(
        'result' => false,
        'msg' => l10n('Can\'t download archive.')
      );
      break;

    case 'archive_error':
      $result = array(
        'result' => false,
        'msg' => l10n('Can\'t read or extract archive.')
      );
      break;

    default:
      $result = array(
        'result' => false,
        'msg' => sprintf(l10n('An error occured during extraction (%s).'), $_GET['upgradestatus'])
      );
  }
  echo json_encode($result);
  exit;
}

if (empty($_REQUEST['id']) or empty($_REQUEST['revision']))
{
  echo json_encode(array(
    'result' => false,
    'msg' => 'Wrong parameters',
    )
  );
  exit;
}

$plugin_id = $_REQUEST['id'];
$revision = $_REQUEST['revision'];

if (isset($plugins->db_plugins_by_id[$plugin_id])
  and $plugins->db_plugins_by_id[$plugin_id]['state'] == 'active')
{
  $plugins->perform_action('deactivate', $plugin_id);

  redirect(AUTOUPDATE_PATH
    . 'ajax/update_plugin.php'
    . '?revision=' . $revision
    . '&id=' . $plugin_id
    . '&reactivate=true');
}

$upgrade_status = $plugins->extract_plugin_files('upgrade', $revision, $plugin_id);

if (isset($_REQUEST['reactivate']))
{
  $plugins->perform_action('activate', $plugin_id);
}

$template->delete_compiled_templates();

redirect(AUTOUPDATE_PATH
  . 'ajax/update_plugin.php'
  . '?id=' . $plugin_id
  . '&upgradestatus='.$upgrade_status
);

?>