<?php

define('PHPWG_ROOT_PATH','../../../');
define('IN_ADMIN', true);
include_once( PHPWG_ROOT_PATH.'include/common.inc.php' );
include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
include_once(PHPWG_ROOT_PATH.'admin/include/functions_plugins.inc.php');

check_status(ACCESS_ADMINISTRATOR);

if (!is_webmaster())
{
  echo json_encode(array(
    'result' => false,
    'msg' => l10n('Webmaster status is required.'),
    )
  );
  exit;
}

if (empty($_REQUEST['id']) or empty($_REQUEST['revision']))
{
  echo json_encode(array(
    'result' => false,
    'msg' => 'Wrong parameters',
    )
  );
  exit;
}

include_once(PHPWG_ROOT_PATH.'admin/include/themes.class.php');
$themes = new themes();

$theme_id = $_REQUEST['id'];
$revision = $_REQUEST['revision'];

$upgrade_status = $themes->extract_theme_files('upgrade', $revision, $theme_id);

switch ($upgrade_status)
{
  case 'ok':
    $result = array(
      'result' => true,
      'msg' => sprintf(l10n('%s has been successfully upgraded.'), $themes->fs_themes[$theme_id]['name'])
    );
    break;

  case 'temp_path_error':
    $result = array(
      'result' => false,
      'msg' => l10n('Can\'t create temporary file.')
    );
    break;

  case 'dl_archive_error':
    $result = array(
      'result' => false,
      'msg' => l10n('Can\'t download archive.')
    );
    break;

  case 'archive_error':
    $result = array(
      'result' => false,
      'msg' => l10n('Can\'t read or extract archive.')
    );
    break;

  default:
    $result = array(
      'result' => false,
      'msg' => sprintf(l10n('An error occured during extraction (%s).'), $upgrade_status)
    );
}

$template->delete_compiled_templates();
echo json_encode($result);
exit;

?>