{combine_script id='jquery.jgrowl' load='footer' require='jquery' path='themes/default/js/plugins/jquery.jgrowl_minimized.js' }
{combine_css path="admin/themes/default/uploadify.jGrowl.css"}

{footer_script require='jquery.jgrowl'}
var extList = new Array();
var confirmMsg  = '{'Are you sure?'|@translate|@escape:'javascript'}';
var errorHead   = '{'ERROR'|@translate|@escape:'javascript'}';
var successHead = '{'Upgrade Complete'|@translate|@escape:'javascript'}';
var errorMsg    = '{'an error happened'|@translate|@escape:'javascript'}';
var restoreMsg  = '{'autoupdate_reset_ignore'|@translate|@escape:'javascript'}';

{literal}
jQuery(document).ready(function() {

	jQuery("td[id^='desc_'], p[id^='revdesc_']").click(function() {
		id = this.id.split('_');
		jQuery("#revdesc_"+id[1]).toggle('blind');
    jQuery(".button_"+id[1]).toggle();
		return false;
	});

  jQuery("#update_all").click(function() {
    if (confirm(confirmMsg)) {
      extList = [];
      jQuery('.updateExtension').each( function() {
        if (jQuery(this).parents('div').css('display') == 'block') {
          extList.push(jQuery(this).attr('onClick'));
        }
      });
      if (extList.length > 0) eval(extList[0]);
    }
    return false;
  });  

  jQuery("#reset_ignore").click(function() {
    jQuery.post(
      "plugins/autoupdate/ajax/ignore_list.php",
      { reset: true },
      function(data) {
        if (data == "ok") {
          jQuery(".pluginBox, fieldset").show();
          jQuery("#up_to_date").hide();
          jQuery("#reset_ignore").hide();
          jQuery("#ignored").hide();
        }
      }
    );
    return false;
  });

});

function checkFieldsets() {
  var types = new Array('plugin', 'theme', 'language');
  var total = 0;
  var ignored = 0;
  for (i=0;i<3;i++) {
    nbExtensions = 0;
    jQuery("div[id^='"+types[i]+"_']").each(function(index) {
        if (jQuery(this).css('display') == 'block')
          nbExtensions++;
        else
          ignored++;
      });
    total = total + nbExtensions;
    if (nbExtensions == 0)
      jQuery("#"+types[i]+"s").hide();
  }

  if (total == 0) {
    jQuery("#update_all").hide();
    jQuery("#up_to_date").show();
  }
  if (ignored > 0) {
    jQuery("#reset_ignore").val(restoreMsg + ' (' + ignored + ')');
  }
}

function upgradeExtension(type, id, revision) {
  jQuery.ajax({
    type: 'POST',
    url: 'plugins/autoupdate/ajax/update_'+type+'.php',
    data: { id: id, revision: revision },
    success: function(data) {
      if (data['result']) {
        jQuery("#"+type+"_"+id).remove();
        checkFieldsets();
        jQuery.jGrowl(
          data['msg'],
          {
            theme:  'success',
            header: successHead,
            life:   4000,
            sticky: false
          }
        );
        if (extList.length > 0) extList.shift();
        if (extList.length > 0) eval(extList[0]);
      } else {
        jQuery.jGrowl(
          data['msg'],
          {
            theme:  'error',
            header: errorHead,
            sticky: true
          }
        );
        extList = [];
      }
    },
    error: function(data) {
      jQuery.jGrowl(
        errorMsg,
        {
          theme:  'error',
          header: errorHead,
          sticky: true
        }
      );
      extList = [];
    },
    dataType: 'json'
  });
  return false;
}

function ignoreExtension(type, id) {
  jQuery.post(
    "plugins/autoupdate/ajax/ignore_list.php",
    { type: type+'s', id: id },
    function(data) {
      if (data == "ok") {
        jQuery("#"+type+"_"+id).hide();
        jQuery("#reset_ignore").show();
        checkFieldsets();
      }
    }
  );
  return false;
}

checkFieldsets();
{/literal}{/footer_script}

<div class="titrePage">
  <h2>Piwigo AutoUpgrade</h2>
</div>

<div>
<input type="button" id="update_all" value="{'autoupdate_update_all'|@translate}">
<input type="button" id="reset_ignore" value="{'autoupdate_reset_ignore'|@translate}" {if !$SHOW_RESET}style="display:none;"{/if}>
</div>

<p id="up_to_date" style="display:none; text-align:left; margin-left:20px;">{'All extensions are up to date.'|@translate}</p>

{if not empty($update_plugins)}
<div>
<fieldset id="plugins">
<legend>{'Plugins which need upgrade'|@translate}</legend>
{foreach from=$update_plugins item=plugin name=plugins_loop}
<div class="pluginBox" id="plugin_{$plugin.PLUGIN_ID}" {if $plugin.IGNORED}style="display:none;"{/if}>
  <table>
    <tr>
      <td class="pluginBoxNameCell">
        {$plugin.EXT_NAME}
      </td>
      <td>
        <a href="#" onClick="upgradeExtension('plugin', '{$plugin.PLUGIN_ID}', {$plugin.REVISION_ID});" class="updateExtension">{'Install'|@translate}</a>
        | <a href="{$plugin.URL_DOWNLOAD}">{'Download'|@translate}</a>
        | <a href="#" onClick="ignoreExtension('plugin', '{$plugin.PLUGIN_ID}');">{'autoupdate_ignore'|@translate}</a>
      </td>
    </tr>
    <tr>
      <td>
        {'Version'|@translate} {$plugin.CURRENT_VERSION}
      </td>
      <td class="pluginDesc" id="desc_{$plugin.ID}">
        <em>{'Downloads'|@translate}: {$plugin.DOWNLOADS}</em>
        <img src="{$ROOT_URL}{$themeconf.admin_icon_dir}/plus.gif" alt="" class="button_{$plugin.ID}">
        <img src="{$ROOT_URL}{$themeconf.admin_icon_dir}/minus.gif" alt="" class="button_{$plugin.ID}" style="display:none;">
        {'New Version'|@translate} : {$plugin.NEW_VERSION}
        | {'By %s'|@translate|@sprintf:$plugin.AUTHOR}
      </td>
    </tr>
    <tr>
      <td></td>
      <td class="pluginDesc">
        <p id="revdesc_{$plugin.ID}" style="display:none;">{$plugin.REV_DESC|htmlspecialchars|nl2br}</p>
      </td>
    </tr>
  </table>
</div>
{/foreach}
</fieldset>
</div>
{/if}

{if not empty($update_themes)}
<div>
<fieldset id="themes">
<legend>{'Themes which need upgrade'|@translate}</legend>
{foreach from=$update_themes item=theme name=themes_loop}
<div class="pluginBox" id="theme_{$theme.THEME_ID}" {if $theme.IGNORED}style="display:none;"{/if}>
  <table>
    <tr>
      <td class="pluginBoxNameCell">
        {$theme.EXT_NAME}
      </td>
      <td>
        <a href="#" onClick="upgradeExtension('theme', '{$theme.THEME_ID}', {$theme.REVISION_ID});" class="updateExtension">{'Install'|@translate}</a>
        | <a href="{$theme.URL_DOWNLOAD}">{'Download'|@translate}</a>
        | <a href="#" onClick="ignoreExtension('theme', '{$theme.THEME_ID}');">{'autoupdate_ignore'|@translate}</a>
      </td>
    </tr>
    <tr>
      <td>
        {'Version'|@translate} {$theme.CURRENT_VERSION}
      </td>
      <td class="pluginDesc" id="desc_{$theme.ID}">
        <em>{'Downloads'|@translate}: {$theme.DOWNLOADS}</em>
        <img src="{$ROOT_URL}{$themeconf.admin_icon_dir}/plus.gif" alt="" class="button_{$theme.ID}">
        <img src="{$ROOT_URL}{$themeconf.admin_icon_dir}/minus.gif" alt="" class="button_{$theme.ID}" style="display:none;">
        {'New Version'|@translate} : {$theme.NEW_VERSION}
        | {'By %s'|@translate|@sprintf:$theme.AUTHOR}
      </td>
    </tr>
    <tr>
      <td></td>
      <td class="pluginDesc">
        <p id="revdesc_{$theme.ID}" style="display:none;">{$theme.REV_DESC|htmlspecialchars|nl2br}</p>
      </td>
    </tr>
  </table>
</div>
{/foreach}
</fieldset>
</div>
{/if}

{if not empty($update_languages)}
<div>
<fieldset id="languages">
<legend>{'Languages which need upgrade'|@translate}</legend>
{foreach from=$update_languages item=language name=languages_loop}
<div class="pluginBox" id="language_{$language.LANGUAGE_ID}" {if $language.IGNORED}style="display:none;"{/if}>
  <table>
    <tr>
      <td class="pluginBoxNameCell">
        {$language.EXT_NAME}
      </td>
      <td>
        <a href="#" onClick="upgradeExtension('language', '{$language.LANGUAGE_ID}', {$language.REVISION_ID});" class="updateExtension">{'Install'|@translate}</a>
        | <a href="{$language.URL_DOWNLOAD}">{'Download'|@translate}</a>
        | <a href="#" onClick="ignoreExtension('language', '{$language.LANGUAGE_ID}');">{'autoupdate_ignore'|@translate}</a>
      </td>
    </tr>
    <tr>
      <td>
        {'Version'|@translate} {$language.CURRENT_VERSION}
      </td>
      <td class="pluginDesc" id="desc_{$language.ID}">
        <em>{'Downloads'|@translate}: {$language.DOWNLOADS}</em>
        <img src="{$ROOT_URL}{$themeconf.admin_icon_dir}/plus.gif" alt="" class="button_{$language.ID}">
        <img src="{$ROOT_URL}{$themeconf.admin_icon_dir}/minus.gif" alt="" class="button_{$language.ID}" style="display:none;">
        {'New Version'|@translate} : {$language.NEW_VERSION}
        | {'By %s'|@translate|@sprintf:$language.AUTHOR}
      </td>
    </tr>
    <tr>
      <td></td>
      <td class="pluginDesc">
        <p id="revdesc_{$language.ID}" style="display:none;">{$language.REV_DESC|htmlspecialchars|nl2br}</p>
      </td>
    </tr>
  </table>
</div>
{/foreach}
</fieldset>
</div>
{/if}
